
# Calcul anticipé de la retenue

## Additionneur 1-bit avec calcul anticipé de la retenue

On propose maintenant de revisiter l'architecture du circuit additionneur pour réduire la longueur du chemin critique. L'idée générale est de permettre un calcul anticipé des retenues, c'est-à-dire sans connaître les résultats des additions des bits de poids plus faibles.

Pour cela, il faut concevoir un additionneur 1-bit un peu différent. On retrouve les 3 entrées précédentes $`a`$, $`b`$ et $`c`$, et 3 sorties :
  - $`s`$, le poids faible de la somme des 3 entrées ;
  - $`g`$, un bit qui indique si la somme va générer une retenue ;
  - $`p`$, un bit qui indique si la somme va propager une retenue ; autrement dit, si la retenue $`c`$ vaut 1, sera-t-elle absorbée ou propagée ?

Un point fondamental pour permettre de réduire le chemin critique est de s'assurer que le calcul de $`p`$ et de $`g`$ ne dépend que de $`a`$ et $`b`$.

  1. Donnez la table de vérité de cet additionneur.
  2. Donnez les équations des sorties en fonction des entrées.
  3. Dessinez le circuit correspondant dans Logisim Evolution.


## L'unité de calcul anticipée de la retenue

Il s'agit maintenant de concevoir un additionneur 4 bits tirant partie des informations de propagation et de génération de retenue.
Pour cela, il est nécessaire de construire une unité de calcul anticipée des retenues. Pour un additionneur 4 bits, cette unité a 9 entrées et 4 sorties. 

Les entrées sont :

  - $`c_0`$, la retenue entrante de l'additionneur, qui s'appliquera à l'addition des deux bits de poids faible.
  - $`p_0`$ à $`p_3`$ les informations de propagation issues des 4 additionneurs 1-bit (du poids faible $`p_0`$ vers le poids fort $`p_3`$).
  - $`g_0`$ à $`g_3`$ les informations de génération issues des 4 additionneurs 1-bit (du poids faible $`g_0`$ vers le poids fort $`g_3`$).

Les sorties sont $`c_1`$, $`c_2`$, $`c_3`$ et $`c_4`$, où $`c_i`$ est la retenue sortante de l'addition des bits de rang $`i-1`$ qui s'applique donc comme retenue entrante pour l'addition des bits de rang $`i`$. À noter que $`c_4`$ n'est pas directement ré-utilisée dans l'additionneur 4-bits.

  1. Donnez l'équation de $`c_1`$ en fonction de $`c_0`$, $`p_0`$ et $`g_0`$.
  2. Donnez l'équation de $`c_2`$ en fonction de $`c_0`$, $`p_0`$, $`g_0`$, $`p_1`$, et $`g_1`$.
  3. Mêmes questions pour $c_3$ et $c_4$.
  5. Pourquoi n'est-il pas pertinent de calculer $`c_{i+1}`$ à partir de $`c_i`$ ?
  6. Dessinez le circuit de l'unité de calcul anticipé de la retenue dans Logisim Evolution.

## Additionneur 4-bits avec calcul anticipé de la retenue

  1. À l'aide de 4 additionneurs 1-bit avec calcul anticipé de la retenue et d'une unité de calcul anticipée de la retenue, dessinez dans Logisim Evolution un additionneur 4-bits avec calcul anticipée de la retenue.
  2. Identifiez le chemin critique de ce circuit et donnez sa longueur (en nombre de porte logique traversées). Comment cela se compare-t-il avec le circuit précédent ?
