
[[_TOC_]]

# Additionneur 16 bits

À partir de l'additionneur 4 bits créés lors de la séance précédente, vous allez construire un additionneur 16 bits. 
L'idée est de reproduire le schéma utilisé pour l'additionneur 4 bits, en assemblant 4 additionneurs 4 bits et une unité de calcul anticipé de la retenue.
Pour cela, vous allez devoir modifier l'additionneur 4 bits en ajoutant 2 sorties :
  - $`sp`$ (pour /super p/) : les 2 $`x`$ 4 bits d'entrées sont tels qu'une retenue entrante va être propagée en sortie ;
  - $`sg`$ (pour /super g/) : les 2 $`x`$ bits d'entrées sont tels qu'une retenue va être générée en sortie.
Pour garder les bonnes propriétés en terme de chemin critique, ces sorties doivent être générées uniquement à partir des bits $`p_i`$ et $`g_i`$ calculés par les additionneurs 1 bit.

  1. Donnez les équations de $`sp`$ et $`sg`$.
  2. Créez dans Logisim Evolution le circuit du nouveau module de calcul anticipé de la retenue. 
  3. Créez dans Logisim Evolution un additionneur 16 bits.
  4. Identifiez le chemin critique de ce circuit et donnez sa longueur en nombre de portes logiques traversées.

# Ajout de la soustraction

Si vous n'avez pas encore fait l'exercice 7 de la feuille /Codage des entiers naturels et relatifs/, allez le faire.

À partir de la technique présentée dans cet exercice et du circuit conçu ci-dessus, vous allez construire un circuit capable de réaliser des additions et des soustractions sur des nombres de 16 bits. 
Ce circuit aura les entrées suivantes :
  - $`A`$, un mot de données de 16 bits,
  - $`B`$, un mot de données de 16 bits,
  - $`op`$, un signal de contrôle sur 1 bit : quand $`op=1`$, le circuit doit calculer $`A+B`$, quand $`op=0`$ il doit calculer $`A-B`$.

Il aura par ailleurs les sorties suivantes :
  - $`R`$ : un mot de 16 bits, le résultat de l'opération demandée,
  - $`c`$ : un bit de statut sur un bit indiquant si l'opération a engendré une retenue,
  - $`z`$ : un bit de statut sur un bit indiquant si le résultat de l'opération est nul,
  - $`s`$ : un bit de statut sur un bit indiquant si le résultat de l'opération, lorsqu'il est interprété en complément à 2, est négatif;
  - $`v`$ : un bit de statut sur un bit indiquant si l'opération a engendré un débordement (au sens de l'arithmétique en complément à 2).

  1. Donnez les équations des différents bits de statuts
  2. Créez le circuit demandé dans Logisim Evolution

# Intégration au sein d'une ALU 16 bits simple

À partir du circuit créé ci-dessus, construisez une ALU simple, capable de réaliser les opérations suivantes sur des mots $`A`$ et $`B`$ de 16 bits :
  - addition,
  - soustraction,
  - décalage logique à gauche de A (vous pouvez utilisez le composant disponible dans la bibliothèque de Logisim Evolution),
  - décalage logique à droite de A (vous pouvez utilisez le composant disponible dans la bibliothèque de Logisim Evolution),
  - complément à 1 sur $`A`$ (négation bit-à-bit),
  - conjonction (et bit-à-bit),
  - disjonction (ou bit-à-bit),
  - ou exclusif bit-à-bit.

Votre ALU produira également à chaque opération les bits de statut $`c`$, $`z`$, $`s`$, et $`v`$.

  1. Quelle doit être la largeur en bits du signal de contrôle ? Proposez un codage des différentes opérations.
  2. Créez le circuit demandé dans Logisim Evolution.

