package main

import (
	"fmt"
	"math"
	"os"
	"strconv"
)

func getX1(x uint32) (uint32) {
	return (x & ((1<<23)-1))
}

func getX2(x uint32) (uint8) {
	return uint8((x >> 31) & 0x1)
}

func getX3(x uint32) (uint8) {
	return uint8((x >> 23))
}


func showFloat(uf uint32) {
	f := math.Float32frombits(uf)
	exp := get???(uf)
	frac := get???(uf)
	sign := get???(uf)

	csign := '+'
	if sign == ??? {
		csign = '-'
	}

	fmt.Printf("\nFloating point value %.10v\n", f)
	fmt.Printf("Bit Representation %#.8x, sign = %x, exponent = %#.2x, fraction = %#.6x\n",
		uf, sign, exp, frac)
	if exp == ??? {
		if frac == ??? {
				fmt.Printf("%cInfinity\n", csign)
		} else {
			fmt.Printf("Not-A-Number\n")
		}
	} else {
		if exp == ??? {
			uexp := ???
			mantissa := ???
			fman := ??? 
			fmt.Printf("Denormalized.  %c%.10f X 2^(%d)\n", csign, fman, uexp)
		} else {
			uexp := ??? 
			mantissa := ???
			fman := ???
			fmt.Printf("Normalized.  %c%.10f X 2^(%d)\n", csign, fman, uexp)
		}
	}
}

func usage(progName string) {
	fmt.Printf("Usage: %s val1 val2 ...\n", progName)
	fmt.Println("Values may be given as hex pattern or floating point number")
	os.Exit(0)
}

func main() {
	for _, argString := range (os.Args[1:]) {
		f, err := strconv.ParseFloat(argString, 32)
		if err == nil {
            // input in decimal format
			showFloat(math.Float32bits(float32(f)))
		} else {
			ui, err := strconv.ParseUint(argString, 0, 32)
			if err == nil {
                // input in integer (hexadecimal?) format
				showFloat(uint32(ui))
			} else {
				fmt.Printf("Error: %v\n", err)
				usage(os.Args[0])
			}
		}
	}
}
